#define stdxxx  stdout
#define DWORD   unsigned long
#define  WORD   unsigned short
#define  BYTE   unsigned char
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern  WORD    DevType(void *idb, WORD devno);  // foCX 3=SATA, 2=RMV, 1=HDD
extern  WORD GetString(void*idbuf, WORD devno, WORD wordval, WORD length, char*buf);
extern  WORD    GetWord(void*idbuf, WORD devno, WORD wordval );
extern  DWORD  GetDword(void*idbuf, WORD devno, WORD wordval );
extern  void    putcc(WORD color_attr);
extern  BYTE    ExistFlag[4];   // 01=ATA, 80h=ATAPI, 00=none
extern  BYTE    IdentifyBuf4[512*4];
extern  WORD    Status2;

static void    SupportOrNOT(WORD wv)
{   
    static char msg_supp[]="supported. ";
    static char msg_notsupp[]="NOT supported. ";
    if (wv) {   
        fprintf(stdxxx,msg_supp);   
    } else {  
        putcc(0xE9);
        fprintf(stdxxx,msg_notsupp); 
        putcc(0xE1);
    }
}

#include "flagval.h"

int Display1Device( int dn , WORD FlagSet)
{   WORD    wv,C0,H0,S0,C,H,S;
    DWORD   LBA,capaMB;
    static char *DevPortName[4]=
    {"Primary Master ","Primary Slave ","Secondary Master ","Secondary Slave "};
    static char sbuf[80];

    wv=GetWord(IdentifyBuf4,dn, 0);      
    putcc(0xE5);
    fprintf(stdxxx," IDE Port [%1d] ",dn);
    putcc(0xE1);
    putcc(0xE5);
    fprintf(stdxxx," %s ",DevPortName[dn]);
    putcc(0xE1);

    if (ExistFlag[dn] == 0)    {
        fprintf(stdxxx," Not connected. (%4.4X)\n",Status2);
        return(0x80);
    }

    if ( ExistFlag[dn] & 0x80 ) {
        fprintf(stdxxx," , ATAPI device ");
    } else {
      if ( wv & 0x8000 )    {
          putcc(0xE9);
          fprintf(stdxxx,"  Non ATA device ,  ");
          putcc(0xE1);
      } else {
          fprintf(stdxxx,"  ATA device ,  ");
      }
      if ( wv & 0x0080 )    {
          putcc(0x61);
          fprintf(stdxxx,"Removable device ");
          putcc(0xE1);
      } else {
          fprintf(stdxxx,"Fixed device ");
      }
    }
    if (DevType(IdentifyBuf4,dn)==3) fprintf(stdxxx," , SATA ");
    fprintf(stdxxx," (%4.4X)\n",Status2);

    GetString(IdentifyBuf4,dn, 27, 40, sbuf);
    fprintf(stdxxx," Model name       : %40.40s\n",sbuf );
    GetString(IdentifyBuf4,dn, 10, 20, sbuf) ;
    fprintf(stdxxx," Serial number    : ");
    if ( FlagSet & F_HIDDEN )   {
        fprintf(stdxxx,"**********\n" );
    } else {
        fprintf(stdxxx,"%10.10s\n",sbuf );
    }
    GetString(IdentifyBuf4,dn, 23, 8, sbuf);
    fprintf(stdxxx," Firmware version : %8.8s\n",sbuf);

    if (ExistFlag[dn] !=0x80) {
      C0=GetWord(IdentifyBuf4,dn, 1);  
      H0=GetWord(IdentifyBuf4,dn, 3);  
      S0=GetWord(IdentifyBuf4,dn, 6);
      C =GetWord(IdentifyBuf4,dn,54);  
      H =GetWord(IdentifyBuf4,dn,55);  
      S =GetWord(IdentifyBuf4,dn,56);
      LBA = GetDword(IdentifyBuf4,dn, 60);
      capaMB=(LBA >>11);  // 512B/sectz肵Ȃ̂ł̕@

      fprintf(stdxxx," Native CHS param : %5u/%3u/%3u \n",C0,H0,S0 );
      fprintf(stdxxx," Current CHS param: %5u/%3u/%3u \n",C ,H ,S  );
      if (LBA==0L)  {
        capaMB= ((DWORD)C0*(DWORD)H0*(DWORD)S0) >>11;
        fprintf(stdxxx," Capacity with LBA: %8.6lXh ,  %lu MiB\n", LBA,capaMB );
      } else {
        fprintf(stdxxx," Capacity with LBA: %8.6lXh ,  %lu MiB\n", LBA,capaMB );
      }
    }
    fprintf(stdxxx," WORD 49 :");
    wv= GetWord(IdentifyBuf4,dn, 49) & 0x0200;
    fprintf(stdxxx," LBA ");    SupportOrNOT(wv);
    wv= GetWord(IdentifyBuf4,dn, 49) & 0x0800;
    fprintf(stdxxx," IORDY ");  SupportOrNOT(wv);
    wv= GetWord(IdentifyBuf4,dn, 49) & 0x0400;
    if (wv) {  fprintf(stdxxx," IORDY can be disabled.");   } 
    fprintf(stdxxx,"\n");


    fprintf(stdxxx," WORD 53 :");
    wv= GetWord(IdentifyBuf4,dn, 53) & 0x0002;
    fprintf(stdxxx," WORD 64-70 ");
    if (wv) {  
        fprintf(stdxxx,"is valid.");   
    }  else {   
        putcc(0xE9);
        fprintf(stdxxx,"is NOT valid.");   
        putcc(0xE1);
    }  
    wv= GetWord(IdentifyBuf4,dn, 53) & 0x0001;
    fprintf(stdxxx,"    WORD 54-58(CHS) ");
    if (wv) {  
        fprintf(stdxxx,"is valid.");   
    } else{
        putcc(0xE9);
        fprintf(stdxxx,"is NOT valid.");   
        putcc(0xE1);
    } 
    fprintf(stdxxx,"\n");


    if ( ExistFlag[dn] !=0x80) {
      wv= GetWord(IdentifyBuf4,dn, 47) & 0x00FF;
      fprintf(stdxxx," WORD 47 :");
      if (wv==0) {
          fprintf(stdxxx," R/W Multiple command ");
          SupportOrNOT(wv);
      } else {
          fprintf(stdxxx," Maximum number of sectors that can be transferred per interrupt= %u",wv);
      }
      fprintf(stdxxx,"\n");
      wv= GetWord(IdentifyBuf4,dn, 59) & 0x0100;
      fprintf(stdxxx," WORD 59 :");
      if (wv) {  
          wv= GetWord(IdentifyBuf4,dn, 59) & 0x00FF;
          fprintf(stdxxx," Multiple sector R/W current setting= %u \n",wv);   
      } else {
          fprintf(stdxxx," Multiple sector R/W setting is ");
          putcc(0xE9);
          fprintf(stdxxx,"invalid on this machine's IDE BIOS.\n");   
          putcc(0xE1);
      }
    }
    fprintf(stdxxx," WORD 64 :");
    wv= GetWord(IdentifyBuf4,dn, 64) & 0x00FF;
    fprintf(stdxxx," Advanced PIO transfer ");
    SupportOrNOT(wv);
    if (wv) {
        wv= GetWord(IdentifyBuf4,dn, 64) & 0x0001;
        if (wv) fprintf(stdxxx," PIO mode 3");
        wv= GetWord(IdentifyBuf4,dn, 64) & 0x0002;
        if (wv) fprintf(stdxxx,",4  ");
        wv= GetWord(IdentifyBuf4,dn, 51);
        wv=wv >>8;  
        if (wv<2)  fprintf(stdxxx," Legacy PIO mode %2X",wv);
    }
    fprintf(stdxxx,"\n");

    wv= GetWord(IdentifyBuf4,dn, 64) & 0x00FF;
    if (wv) {
      fprintf(stdxxx," WORD 67 :");
      wv= GetWord(IdentifyBuf4,dn, 67);
      fprintf(stdxxx," Minimum PIO Transfer Cycle Time= %u ns (without IORDY Flow Control)\n",wv);

      fprintf(stdxxx," WORD 68 :");
      wv= GetWord(IdentifyBuf4,dn, 68);
      fprintf(stdxxx," Minimum PIO Transfer Cycle Time= %u ns (with IORDY Flow Control)\n",wv);
    }

    wv= GetWord(IdentifyBuf4,dn, 83);
    if (wv !=0) {
        fprintf(stdxxx," W 82-83 :");
        if (wv & 0x0400) fprintf(stdxxx," [Big Drive(48bit)] ");
        if (wv & 0x0100) fprintf(stdxxx," [SET MAX] ");
        if (wv & 0x0004) {
            putcc(0xE9);
            fprintf(stdxxx," [CFA] ");
            putcc(0xE1);
        }
    }
    wv= GetWord(IdentifyBuf4,dn, 82);
    if (wv !=0) {
        if (wv & 0x0400) fprintf(stdxxx," [HPA] ");
        if (wv & 0x0001) fprintf(stdxxx," [SMART] ");
        if (wv & 0x0200) fprintf(stdxxx," [DEV RST] ");
    }
    fprintf(stdxxx,"\n");
    
    wv= GetWord(IdentifyBuf4,dn, 222);
    if (wv !=0) {
        fprintf(stdxxx," WORD 222:");
        fprintf(stdxxx," SATA ");
        if (wv & 0x0010) fprintf(stdxxx,"Rev. 2.6   ");
        if (wv & 0x0008) fprintf(stdxxx,"Rev. 2.5   ");
        if (wv & 0x0004) fprintf(stdxxx,"SATA II ex.   ");
        if (wv & 0x0002) fprintf(stdxxx,"SATA 1.0a   ");
        if (wv & 0x0001) fprintf(stdxxx,"ATA8-AST ");
        fprintf(stdxxx,"\n");
    }

    return(dn);
}
